

Procedure mathPlot(*math1, *math2, *math3=0, *save=0)
  ; Wenn einer der Parameter ein Error-Objekt ist,
  ; gibt die Funktion die Kopie des Objektes zurck.
  If isTrue(isError(*math1))
    ProcedureReturn copyMath(*math1, *save)
  ElseIf isTrue(isError(*math2))
    ProcedureReturn copyMath(*math2, *save)
  ElseIf (*math3 <> 0)
    If isTrue(isError(*math3))
      ProcedureReturn copyMath(*math3, *save)
    EndIf
  EndIf
  ; Wenn der 2. Parameter kein Equal-Operator und kein
  ; Range-Objekt ist, wird ein Error-Objekt zurckgegeben.
  If isFalse(isType(*math2,newSymbol("="))) Or isFalse(isRange(mathOpRight(*math2)))
    ProcedureReturn newError(46, *math2, *save)
  EndIf
  ; Wenn der 3. Parameter kein Equal-Operator oder kein
  ; Range-Objekt ist, wird ein Error-Objekt zurckgegeben.
  If (*math3 <> 0)
    If isFalse(isType(*math3,newSymbol("="))) And isFalse(isRange(mathOpRight(*math3)))
      ProcedureReturn newError(46, *math3, *save)
    EndIf
  EndIf
  ProcedureReturn newFunction(@mathPlot(), 4, *math1, *math2, *math3, 0, *save)
EndProcedure
newFunc(@mathPlot(), "plot", 3, 1)


#step = 500

Procedure CreatePlot(*plotmath, px, py)
  *math1 = mathFuncArg(*plotmath, newQWord(0))
  *math2 = mathFuncArg(*plotmath, newQWord(1))
  If (mathValQWord(mathNumbFuncArg(*plotmath)) > 2)
    *math3 = mathFuncArg(*plotmath, newQWord(2))
  EndIf
  Box(px, py, 501, 501, RGB(255,255,255))
  var.s = mathValVariable(mathOpLeft(*math2))
  *min = mathOpLeft (mathOpRight(*math2))
  *max = mathOpRight(mathOpRight(*math2))
  If (*math3 = 0) Or isTrue(isVariable(*math3))
    ; Wenn der y-Bereich nicht angeben wird,
    ; wird er berechnet:
    For i = 0 To #step
      *var = mathSub(*max, *min)
      *var = mathMul(*var, newRatio(i,#step))
      *var = mathAdd(*var, *min)
      newValueVar(var, *var)
      *math = mathSimple(copyMath(*math1))
      If isTrue(isComplex(*math))
        If isTrue(mathGreat(newDouble(0.0000001), mathAbs(mathImagPart(*math))))
          *math = mathRealPart(*math)
        EndIf
      EndIf
      If isTrue(isReal(*math))
        If (*ymin = 0)
          *ymin = *math
          *ymax = *math
        Else
          If isTrue(mathGreat(*ymin,*math))
            *ymin = *math
          EndIf
          If isTrue(mathGreat(*math,*ymax))
            *ymax = *math
          EndIf
        EndIf
      EndIf
    Next
    If isTrue(mathEqual(*ymin,*ymax))
      *ymin = mathAdd(*ymin, newQWord(-1))
      *ymax = mathAdd(*ymax, newQWord(1))
    EndIf
    mathEval(var+":=")
  Else
    *ymin = mathOpLeft (mathOpRight(*math3))
    *ymax = mathOpRight(mathOpRight(*math3))
  EndIf
  min.d  = mathValDouble(mathFloat(*min))
  max.d  = mathValDouble(mathFloat(*max))
  ymin.d = mathValDouble(mathFloat(*ymin))
  ymax.d = mathValDouble(mathFloat(*ymax))
  If (min < max) And (ymin < ymax)
    Line(px-min/(max-min)*500, py, 0, 500, 0)
    Line(px, py+500+ymin/(ymax-ymin)*500, 500, 0, 0)
    For x = 0 To 20
      Line(px-min/(max-min)*500-5, py+x*25, 10, 0, 0)
      Line(px+x*25, py+495+ymin/(ymax-ymin)*500, 0, 10, 0)
    Next
    last = 0
    col = RGB(192,0,0)
    savey.d = 0
    ; Der Graph wird nun gezeichnet
    For i = 0 To #step
      *var = mathSub(*max, *min)
      *var = mathMul(*var, newRatio(i,#step))
      *var = mathAdd(*var, *min)
      newValueVar(var, *var)
      *math = mathSimple(copyMath(*math1))
      If isTrue(isComplex(*math))
        If isTrue(mathGreat(newDouble(0.0000001), mathAbs(mathImagPart(*math))))
          *math = mathRealPart(*math)
        EndIf
      EndIf
      If isTrue(isReal(*math))
        *math = mathFloat(*math)
        yy.d = (mathValDouble(*math)-ymin)/(ymax-ymin)*500
        If (mathValDouble(*math) <= ymax) And (mathValDouble(*math) >= ymin)
          Plot(px+500*i/#step, py+500-yy, col)
        EndIf
        If last
          LineXY(px+500*(i-1)/#step, py+500-savey, px+500*i/#step, py+500-yy, col)
        EndIf
        savey = yy
        last = 1
      Else
        last = 0
      EndIf
    Next
    mathEval(var+":=")
  EndIf
EndProcedure

; IDE Options = PureBasic v4.00 (Windows - x86)