
IncludeFile "Graph.pbi"


Structure lines
  tex.l
  inp.l
  ima.l
EndStructure

Global NewList lines.lines()
Global NewList *maths()


Global winwid = 800, winhei = 600
Global inputhei
Global numbline
Global *LastMath


Procedure InitFont()
  LoadFont(0, "Courier New", 10)
  LoadFont(1, "Times New Roman", 12)
  LoadFont(2, "Times New Roman", 10)
  LoadFont(3, "Times New Roman", 8)
  If StartDrawing(WindowOutput(0))
    DrawingFont(FontID(0))
    inputhei = TextHeight(" ")
    StopDrawing()
  EndIf
EndProcedure


Procedure.s MyStrD(double.d)
  Protected str.s
  str = StrD(double)
  While (Right(str,1) = "0")
    str = PeekS(@str, Len(str)-1)
  Wend
  ProcedureReturn str
EndProcedure


#KlAuf = 1
#KlZu = 2
#KlRund = 4
#KlEck = 8
#KlGesw = 16

Procedure DisplayKl(typ, px, py, hei)
  If (typ & #KlRund)
    If (typ & #KlAuf)
      Line(px+3, py+1, 2, -2)
      Line(px+2, py+2, 0,  2)
      Line(px+1, py+4, 0,  3)
      If (hei > 14)
        Line(px, py+7, 0, hei-14)
      EndIf
      Line(px+1, py+hei-7, 0, 3)
      Line(px+2, py+hei-4, 0, 2)
      Line(px+3, py+hei-2, 2, 2)
    Else
      Line(px+1, py+1, 2, 2)
      Line(px+2, py+2, 0, 2)
      Line(px+3, py+4, 0, 3)
      If (hei > 14)
        Line(px+4, py+7, 0, hei-14)
      EndIf
      Line(px+3, py+hei-7, 0,  3)
      Line(px+2, py+hei-4, 0,  2)
      Line(px+1, py+hei-2, 2, -2)
    EndIf
  ElseIf (typ & #KlEck)
    If (typ & #KlAuf)
      Line(px, py+1, 4, 0)
      Line(px, py+1, 0, hei-2)
      Line(px, py+hei-2, 4, 0)
    Else
      Line(px+1, py+1, 4, 0)
      Line(px+4, py+1, 0, hei-2)
      Line(px+1, py+hei-2, 4, 0)
    EndIf
  ElseIf (typ & #KlGesw)
    If (hei > 24)
      gr = 1
    EndIf
    If (typ & #KlAuf)
      Plot(px+1-gr, py+hei/2)
      If (gr = 1)
        Plot(px+1, py+hei/2-1)
        Plot(px+1, py+hei/2+1)
      EndIf
      LineXY(px+2, py+3, px+2, py+hei/2-1-gr)
      LineXY(px+2, py+hei/2+1+gr, px+2, py+hei-4)
      Line(px+3, py+2, 1, -1)
      Line(px+3, py+hei-3, 1, 1)
    Else
      Plot(px+3+gr, py+hei/2)
      If (gr = 1)
        Plot(px+3, py+hei/2-1)
        Plot(px+3, py+hei/2+1)
      EndIf
      LineXY(px+2, py+3, px+2, py+hei/2-1-gr)
      LineXY(px+2, py+hei/2+1+gr, px+2, py+hei-4)
      Line(px+1, py+2, -1, -1)
      Line(px+1, py+hei-3, -1, 1)
    EndIf
  EndIf
EndProcedure


Procedure GetPrio(*math)
  If (isTrue(isRange(*math)) Or isTrue(isOperator(*math)))
    typ.s = mathValSymbol(getType(*math))
    If (typ = "^")
      ProcedureReturn 1
    ElseIf (typ = "*")
      ProcedureReturn 2
    ElseIf (typ = "+")
      ProcedureReturn 3
    ElseIf (typ = "..")
      ProcedureReturn 4
    ElseIf (typ = "=") Or (typ = ">") Or (typ = ">=") Or (typ = "<>")
      ProcedureReturn 5
    ElseIf (typ = "&") Or (typ = "|") Or (typ = "!")
      ProcedureReturn 6
    EndIf
  EndIf
EndProcedure

Procedure IsLeftKl(*math)
  If (GetPrio(mathOpLeft(*math)) > GetPrio(*math))
    ProcedureReturn 1
  ElseIf isTrue(isNumber(mathOpLeft(*math)))
    typ.s = mathValSymbol(getType(*math))
    If (typ = "*")
      If isTrue(mathEqual(newQWord(-1),mathOpLeft(*math)))
        ProcedureReturn 2
      EndIf
    EndIf
    If (typ = "^")
      If isTrue(isRatio(mathOpLeft(*math)))
        ProcedureReturn 1
      EndIf
    EndIf
  ElseIf (GetPrio(*math) = 1)
    If (GetPrio(mathOpLeft(*math)) = 1)
      ProcedureReturn 1
    EndIf
  EndIf
EndProcedure

Procedure IsRightKl(*math)
  If (GetPrio(mathOpRight(*math)) > GetPrio(*math))
    ProcedureReturn 1
  ElseIf isTrue(isNumber(mathOpRight(*math)))
    If isTrue(mathGreat(newQWord(0),mathOpRight(*math)))
      ProcedureReturn 1
    EndIf
    If (GetPrio(*math) = 1)
      If isTrue(isRatio(mathOpRight(*math)))
        ProcedureReturn 1
      EndIf
    EndIf
  ElseIf (GetPrio(*math) = 1)
    If (GetPrio(mathOpRight(*math)) = 1)
      ProcedureReturn 1
    EndIf
  ElseIf (GetPrio(*math) = 3)
    *save = mathOpRight(*math)
    While (GetPrio(*save) = 2)
      *save = mathOpLeft(*save)
      If isTrue(isNumber(*save))
        If isTrue(mathGreat(newQWord(0),*save))
          ProcedureReturn 2
        EndIf
      EndIf
    Wend
  EndIf
EndProcedure


Macro CreateSet(wid, y1, y2)
  (wid<<32+y1<<16+y2)
EndMacro

Macro SetWidth(quad)
  (quad>>32)
EndMacro

Macro SetY1(quad)
  ((quad-SetWidth(quad)<<32)>>16)
EndMacro

Macro SetY2(quad)
  ((quad-SetWidth(quad)<<32)-(SetY1(quad)<<16))
EndMacro


Procedure.q MathSettings(*math, font)
  While (IsFont(font) = 0)
    font - 1
  Wend
  DrawingFont(FontID(font))
  savefont = font
  If isTrue(isQWord(*math))
    qword.q = mathValQWord(*math)
    If (qword >= 0)
      wid = TextWidth(StrQ(qword))
    Else
      wid = TextWidth("_"+StrQ(-qword))
    EndIf
    y1 = TextHeight(" ")/2
    y2 = y1
  ElseIf isTrue(isDouble(*math))
    double.d = mathValDouble(*math)
    If (double >= 0)
      wid = TextWidth(MyStrD(double))
    Else
      wid = TextWidth("_"+MyStrD(-double))
    EndIf
    y1 = TextHeight(" ")/2
    y2 = y1
  ElseIf isTrue(isRatio(*math))
    isratio = 1
    *num = mathNumerator(*math)
    *den = mathDenominator(*math)
  ElseIf isTrue(isComplex(*math))
    real.q = MathSettings(mathRealPart(*math), font)
    imag.q = MathSettings(mathImagPart(*math), font)
    wid = TextWidth("#c, ")+SetWidth(real)+SetWidth(imag)+10
    If (SetY1(real) > SetY1(imag))
      y1 = SetY1(real)
    Else: y1 = SetY1(imag)
    EndIf
    If (SetY2(real) > SetY2(imag))
      y2 = SetY2(real)
    Else: y2 = SetY2(imag)
    EndIf
  ElseIf isTrue(isBoolean(*math))
    If isTrue(*math)
      wid = TextWidth("true")
    Else
      wid = TextWidth("false")
    EndIf
    y1 = TextHeight(" ")/2
    y2 = y1
  ElseIf isTrue(isSymbol(*math))
    wid = TextWidth("'"+mathValSymbol(*math)+"'")
    y1 = TextHeight(" ")/2
    y2 = y1
  ElseIf isTrue(isString(*math))
    wid = TextWidth(Chr(34)+mathValString(*math)+Chr(34))
    y1 = TextHeight(" ")/2
    y2 = y1
  ElseIf isTrue(isVariable(*math))
    wid = TextWidth(mathValVariable(*math))
    y1 = TextHeight(" ")/2
    y2 = y1
  ElseIf isTrue(isMathSymbol(*math))
    idx = mathValMathSymbol(*math)
    If (idx = #MathSymbol_Infinity) Or (idx = #MathSymbol_NegInfinity)
      wid = 12
      If (idx = #MathSymbol_NegInfinity)
        wid + TextWidth("_")
      EndIf
    Else
      text.s = "undefined"
      wid = TextWidth(text)
    EndIf
    y1 = TextHeight(" ")/2
    y2 = y1
  ElseIf isTrue(isError(*math))
    *error = mathErrorMath(*math)
    wid = TextWidth("<Error> "+mathErrorText(mathErrorIndex(*math)))
    y1 = TextHeight(" ")/2
    y2 = y1
    If (*error <> 0)
      error.q = MathSettings(*error, font)
      wid + TextWidth(" ")
      wid + SetWidth(error)
      If (SetY1(error) > y1)
        y1 = SetY1(error)
      EndIf
      If (SetY2(error) > y2)
        y2 = SetY2(error)
      EndIf
    EndIf
  ElseIf isTrue(isSet(*math))
    wid = 10
    y1 = TextHeight(" ")/2
    y2 = y1
    numb = mathValQWord(mathWidth(*math))
    For i = 0 To numb-1
      set.q = MathSettings(mathGetArg(*math, newQWord(i)), font)
      wid + SetWidth(set)
      If (i < numb-1)
        wid + TextWidth(", ")
      EndIf
      If (SetY1(set) > y1)
        y1 = SetY1(set)
      EndIf
      If (SetY2(set) > y2)
        y2 = SetY2(set)
      EndIf
    Next
    If (numb = 0)
      wid + 5
    EndIf
  ElseIf isTrue(isArray(*math))
    nw = mathValQWord(mathWidth(*math))
    nh = mathValQWord(mathHeight(*math))
    wid = 0
    For xx = 0 To nw-1
      maxwid = 0
      For yy = 0 To nh-1
        set.q = MathSettings(mathGetArg(*math,newQWord(yy*nw+xx)), font)
        If (SetWidth(set) > maxwid)
          maxwid = SetWidth(set)
        EndIf
      Next
      wid + maxwid+10
    Next
    hei = 0
    For yy = 0 To nh-1
      maxy1 = 0
      maxy2 = 0
      For xx = 0 To nw-1
        set.q = MathSettings(mathGetArg(*math,newQWord(yy*nw+xx)), font)
        If (SetY1(set) > maxy1)
          maxy1 = SetY1(set)
        EndIf
        If (SetY2(set) > maxy2)
          maxy2 = SetY2(set)
        EndIf
      Next
      If ((nh % 2) = 0)
        If (yy = nh/2)
          y1 = hei-2
        EndIf
      Else
        If (yy = (nh-1)/2)
          y1 = hei+maxy1
        EndIf
      EndIf
      hei + maxy1+maxy2+5
    Next
    hei - 5
    y2 = hei-y1
  ElseIf isTrue(isFunction(*math))
    name.s = mathValFunction(*math)
    If (name = "plot")
      wid = 501
      y1 = 250
      y2 = 251
    Else
      wid = TextWidth(mathValFunction(*math))+10
      y1 = TextHeight(" ")/2
      y2 = y1
      numb = mathValQWord(mathNumbFuncArg(*math))
      For i = 0 To numb-1
        set.q = MathSettings(mathFuncArg(*math, newQWord(i)), font)
        wid + SetWidth(set)
        If (i < numb-1)
          wid + TextWidth(", ")
        EndIf
        If (SetY1(set) > y1)
          y1 = SetY1(set)
        EndIf
        If (SetY2(set) > y2)
          y2 = SetY2(set)
        EndIf
      Next
    EndIf
  ElseIf isTrue(isRange(*math)) Or isTrue(isOperator(*math))
    typ.s = mathValSymbol(getType(*math))
    leftkl  = IsLeftKl (*math)
    rightkl = IsRightKl(*math)
    *left  = mathOpLeft (*math)
    *right = mathOpRight(*math)
    If (typ = "^")
      If isTrue(isNumber(*right))
        If isTrue(mathGreat(newQWord(0),*right))
          isratio = 1
          *den = mathPow(*math,newQWord(-1))
        EndIf
      EndIf
    ElseIf (typ = "*")
      *num = newQWord(1)
      *den = newQWord(1)
      *smath = *math
      raus = 0
      Repeat
        isok = 0
        If (raus = 0)
          *sleft  = mathOpLeft (*smath)
          *sright = mathOpRight(*smath)
        EndIf
        styp.s = mathValSymbol(getType(*sright))
        If (styp = "^")
          *rr = mathOpRight(*sright)
          If isTrue(isNumber(*rr))
            If isTrue(mathGreat(newQWord(0),*rr))
              isratio = 1
              isok = 1
              *den = mathMul(mathPow(*sright,newQWord(-1)), *den)
            EndIf
          EndIf
        ElseIf isTrue(isRatio(*sright))
          isratio = 1
          isok = 1
          *num = mathMul(mathNumerator(*sright), *num)
          *den = mathMul(mathDenominator(*sright), *den)
        EndIf
        If (isok = 0)
          *num = mathMul(*sright, *num)
        EndIf
        If (raus = 0)
          styp = mathValSymbol(getType(*sleft))
          If (styp = "*")
            *smath = *sleft
          Else
            raus = 1
            *sright = *sleft
          EndIf
        Else
          raus = 2
        EndIf
      Until (raus = 2)
    EndIf
    If (isratio = 0)
      left.q  = MathSettings(*left, font)
      If (leftkl = 1)
        wid + 10
      EndIf
      If (rightkl = 1)
        wid + 10
      EndIf
      If (typ = "*")
        wid + 3
      ElseIf (typ = "&")
        wid + TextWidth(" and ")
      ElseIf (typ = "|")
        wid + TextWidth(" or ")
      ElseIf (typ = "!")
        wid + TextWidth(" xor ")
      ElseIf (typ = "^")
        font + 1
      Else
        If (rightkl <> 2)
          wid + TextWidth(typ)+6
        Else
          wid + 4
        EndIf
      EndIf
      yy = TextHeight(" ")/2
      right.q = MathSettings(*right, font)
      If (leftkl = 2)
        wid + TextWidth("_")-1
      Else
        wid + SetWidth(left)
      EndIf
      wid + SetWidth(right)
      If (typ = "^")
        y1 = SetY1(left)-yy+SetY1(right)+SetY2(right)
        y2 = SetY2(left)
      Else
        If (SetY1(left) > SetY1(right))
          y1 = SetY1(left)
        Else: y1 = SetY1(right)
        EndIf
        If (SetY2(left) > SetY2(right))
          y2 = SetY2(left)
        Else: y2 = SetY2(right)
        EndIf
      EndIf
    EndIf
  EndIf
  If (isratio = 1)
    wid = 0
    If (*num = 0)
      *num = newQWord(1)
    EndIf
    *save = *num
    While 1
      If isTrue(isNumber(*save))
        If isTrue(mathGreat(newQWord(0),*save))
          *num = mathMul(newQWord(-1), *num)
          wid + TextWidth("_")+2
          Break
        EndIf
        Break
      ElseIf (GetPrio(*save) <> 2)
        Break
      EndIf
      *save = mathOpLeft(*save)
    Wend
    num.q = MathSettings(*num, font)
    den.q = MathSettings(*den, font)
    If (SetWidth(num) > SetWidth(den))
      wid + SetWidth(num)+4
    Else
      wid + SetWidth(den)+4
    EndIf
    y1 = SetY1(num)+SetY2(num)
    y2 = SetY1(den)+SetY2(den)
  EndIf
  DrawingFont(FontID(savefont))
  ProcedureReturn CreateSet(wid, y1, y2)
EndProcedure


Procedure DisplayMath(*math, px, py, font)
  While (IsFont(font) = 0)
    font - 1
  Wend
  DrawingFont(FontID(font))
  savefont = font
  If isTrue(isQWord(*math))
    qword.q = mathValQWord(*math)
    If (qword < 0)
      wid = TextWidth("_")
      Line(px, py, wid-2, 0)
      DrawText(px+wid, py-TextHeight(" ")/2, StrQ(-qword))
    Else
      DrawText(px, py-TextHeight(" ")/2, StrQ(qword))
    EndIf
  ElseIf isTrue(isDouble(*math))
    double.d = mathValDouble(*math)
    If (double < 0)
      wid = TextWidth("_")
      Line(px, py, wid-2, 0)
      DrawText(px+wid, py-TextHeight(" ")/2, MyStrD(-double))
    Else
      DrawText(px, py-TextHeight(" ")/2, MyStrD(double))
    EndIf
  ElseIf isTrue(isRatio(*math))
    isratio = 1
    *num = mathNumerator(*math)
    *den = mathDenominator(*math)
  ElseIf isTrue(isComplex(*math))
    set.q = MathSettings(*math, font)
    y = SetY1(set)
    hei = y+SetY2(set)
    real.q = MathSettings(mathRealPart(*math), font)
    imag.q = MathSettings(mathImagPart(*math), font)
    yy = TextHeight(" ")/2
    px = DrawText(px, py-yy, "#c")
    DisplayKl(#KlAuf|#KlRund, px, py-y, hei): px+5
    DisplayMath(mathRealPart(*math), px, py, font)
    px + SetWidth(real)
    px = DrawText(px, py-yy, ", ")
    DisplayMath(mathImagPart(*math), px, py, font)
    px + SetWidth(imag)
    DisplayKl(#KlZu|#KlRund, px, py-y, hei)
  ElseIf isTrue(isBoolean(*math))
    If isTrue(*math)
      DrawText(px, py-TextHeight(" ")/2, "true")
    Else
      DrawText(px, py-TextHeight(" ")/2, "false")
    EndIf
  ElseIf isTrue(isSymbol(*math))
    DrawText(px, py-TextHeight(" ")/2, "'"+mathValSymbol(*math)+"'")
  ElseIf isTrue(isString(*math))
    DrawText(px, py-TextHeight(" ")/2, Chr(34)+mathValString(*math)+Chr(34))
  ElseIf isTrue(isVariable(*math))
    DrawText(px, py-TextHeight(" ")/2, mathValVariable(*math))
  ElseIf isTrue(isMathSymbol(*math))
    idx = mathValMathSymbol(*math)
    If (idx = #MathSymbol_Infinity) Or (idx = #MathSymbol_NegInfinity)
      If (idx = #MathSymbol_NegInfinity)
        wid = TextWidth("_")
        Line(px, py, wid-2, 0)
        px + wid
      EndIf
      Line(px+1, py-1, 0, 4)
      Line(px+2, py-2, 2, 0)
      Line(px+2, py+3, 2, 0)
      Plot(px+4, py-1)
      Plot(px+4, py+2)
      Line(px+5, py  , 0, 2)
      Plot(px+6, py-1)
      Plot(px+6, py+2)
      Line(px+7, py-2, 3, 0)
      Line(px+7, py+3, 3, 0)
      Line(px+10,py-1, 0, 4)
    Else
      text.s = "undefined"
      DrawText(px, py-TextHeight(" ")/2, text)
    EndIf
  ElseIf isTrue(isError(*math))
    *error = mathErrorMath(*math)
    px = DrawText(px, py-TextHeight(" ")/2, "<Error> "+mathErrorText(mathErrorIndex(*math)))
    If (*error <> 0)
      px = DrawText(px, py-TextHeight(" ")/2, " ")
      DisplayMath(*error, px, py, font)
    EndIf
  ElseIf isTrue(isSet(*math))
    set.q = MathSettings(*math, font)
    y1 = SetY1(set)
    hei = y1+SetY2(set)
    DisplayKl(#KlAuf|#KlGesw, px, py-y1, hei): px+5
    numb = mathValQWord(mathWidth(*math))
    For i = 0 To numb-1
      *arg = mathGetArg(*math, newQWord(i))
      set.q = MathSettings(*arg, font)
      DisplayMath(*arg, px, py, font)
      px + SetWidth(set)
      If (i < numb-1)
        px = DrawText(px, py-TextHeight(" ")/2, ", ")
      EndIf
    Next
    If (numb = 0)
      px + 5
    EndIf
    DisplayKl(#KlZu|#KlGesw, px, py-y1, hei): px+5
  ElseIf isTrue(isArray(*math))
    set.q = MathSettings(*math, font)
    y1 = SetY1(set)
    hei = y1+SetY2(set)
    DisplayKl(#KlAuf|#KlEck, px, py-y1, hei): px+5
    nw = mathValQWord(mathWidth(*math))
    nh = mathValQWord(mathHeight(*math))
    savex = px
    savey = py
    For yy = 0 To nh-1
      px = savex
      For xx = 0 To nw-1
        maxwid = 0
        For y = 0 To nh-1
          *arg = mathGetArg(*math,newQWord(y*nw+xx))
          args.q = MathSettings(*arg, font)
          If (SetWidth(args) > maxwid)
            maxwid = SetWidth(args)
          EndIf
        Next
        maxy1 = 0
        maxy2 = 0
        For x = 0 To nw-1
          *arg = mathGetArg(*math,newQWord(yy*nw+x))
          args.q = MathSettings(*arg, font)
          If (SetY1(args) > maxy1)
            maxy1 = SetY1(args)
          EndIf
          If (SetY2(args) > maxy)
            maxy2 = SetY2(args)
          EndIf
        Next
        maxhei = maxy1+maxy2
        *arg = mathGetArg(*math,newQWord(yy*nw+xx))
        args.q = MathSettings(*arg, font)
        plx = (maxwid-SetWidth(args))/2
        ply = (maxhei-SetY1(args)-SetY2(args))/2+SetY1(args)-y1
        DisplayMath(*arg, px+plx, py+ply, font)
        px + maxwid+10
      Next
      px - 10
      py + maxy1+maxy2+5
    Next
    DisplayKl(#KlZu|#KlEck, px, savey-y1, hei): px+5
  ElseIf isTrue(isFunction(*math))
    name.s = mathValFunction(*math)
    If (name = "plot")
      set.q = MathSettings(*math, font)
      y1 = SetY1(set)
      CreatePlot(*math, px, py-y1)
    Else
      set.q = MathSettings(*math, font)
      y1 = SetY1(set)
      hei = y1+SetY2(set)
      px = DrawText(px, py-TextHeight(" ")/2, name)
      DisplayKl(#KlAuf|#KlRund, px, py-y1, hei): px+5
      numb = mathValQWord(mathNumbFuncArg(*math))
      For i = 0 To numb-1
        *arg = mathFuncArg(*math, newQWord(i))
        set.q = MathSettings(*arg, font)
        DisplayMath(*arg, px, py, font)
        px + SetWidth(set)
        If (i < numb-1)
          px = DrawText(px, py-TextHeight(" ")/2, ", ")
        EndIf
      Next
      DisplayKl(#KlZu|#KlRund, px, py-y1, hei): px+5
    EndIf
  ElseIf isTrue(isRange(*math)) Or isTrue(isOperator(*math))
    set.q = MathSettings(*math, font)
    typ.s = mathValSymbol(getType(*math))
    *left = mathOpLeft(*math)
    *right = mathOpRight(*math)
    If (typ = "^")
      If isTrue(isNumber(*right))
        If isTrue(mathGreat(newQWord(0),*right))
          isratio = 1
          *den = mathPow(*math,newQWord(-1))
        EndIf
      EndIf
    ElseIf (typ = "*")
      *num = newQWord(1)
      *den = newQWord(1)
      *smath = *math
      raus = 0
      Repeat
        isok = 0
        If (raus = 0)
          *sleft  = mathOpLeft (*smath)
          *sright = mathOpRight(*smath)
        EndIf
        styp.s = mathValSymbol(getType(*sright))
        If (styp = "^")
          *rr = mathOpRight(*sright)
          If isTrue(isNumber(*rr))
            If isTrue(mathGreat(newQWord(0),*rr))
              isratio = 1
              isok = 1
              *den = mathMul(mathPow(*sright,newQWord(-1)), *den)
            EndIf
          EndIf
        ElseIf isTrue(isRatio(*sright))
          isratio = 1
          isok = 1
          *num = mathMul(mathNumerator(*sright), *num)
          *den = mathMul(mathDenominator(*sright), *den)
        EndIf
        If (isok = 0)
          *num = mathMul(*sright, *num)
        EndIf
        If (raus = 0)
          styp = mathValSymbol(getType(*sleft))
          If (styp = "*")
            *smath = *sleft
          Else
            raus = 1
            *sright = *sleft
          EndIf
        Else
          raus = 2
        EndIf
      Until (raus = 2)
    EndIf
    If (isratio = 0)
      leftkl  = IsLeftKl (*math)
      rightkl = IsRightKl(*math)
      left.q = MathSettings(*left, font)
      If (leftkl = 1)
        DisplayKl(#KlAuf|#KlRund, px, py-SetY1(left), SetY1(left)+SetY2(left)): px+5
      EndIf
      If (leftkl = 2)
        wid = TextWidth("_")
        Line(px, py, wid-2, 0)
        px + wid-1
      Else
        DisplayMath(*left, px, py, font)
        px + SetWidth(left)
      EndIf
      If (leftkl = 1)
        DisplayKl(#KlZu|#KlRund, px, py-SetY1(left), SetY1(left)+SetY2(left)): px+5
      EndIf
      If (typ = "*")
        px + 3
      ElseIf (typ = "&")
        px = DrawText(px, py-TextHeight(" ")/2, " and ")
      ElseIf (typ = "|")
        px = DrawText(px, py-TextHeight(" ")/2, " or ")
      ElseIf (typ = "!")
        px = DrawText(px, py-TextHeight(" ")/2, " xor ")
      ElseIf (typ = "^")
        font + 1
      Else
        If (rightkl <> 2)
          px = DrawText(px+3, py-TextHeight(" ")/2, typ)
          px + 3
        Else
          px + 4
        EndIf
      EndIf
      yy = TextHeight(" ")/2
      right.q = MathSettings(*right, font)
      heiR = SetY1(right)+SetY2(right)
      If (typ = "^")
        ny = py-SetY1(left)+yy-SetY2(right)
      Else
        ny = py
      EndIf
      If (rightkl = 1)
        DisplayKl(#KlAuf|#KlRund, px, ny-SetY1(right), heiR): px+5
      EndIf
      DisplayMath(*right, px, ny, font)
      px + SetWidth(right)
      If (rightkl = 1)
        DisplayKl(#KlZu|#KlRund, px, ny-SetY1(right), heiR): px+5
      EndIf
    EndIf
  EndIf
  If (isratio = 1)
    If (*num = 0)
      *num = newQWord(1)
    EndIf
    *save = *num
    While 1
      If isTrue(isNumber(*save))
        If isTrue(mathGreat(newQWord(0),*save))
          *num = mathMul(newQWord(-1), *num)
          wid = TextWidth("_")
          Line(px, py, wid-2, 0)
          px + wid+2
          Break
        EndIf
        Break
      ElseIf (GetPrio(*save) <> 2)
        Break
      EndIf
      *save = mathOpLeft(*save)
    Wend
    num.q = MathSettings(*num, font)
    den.q = MathSettings(*den, font)
    wid = SetWidth(den)
    If (SetWidth(num) > SetWidth(den))
      wid = SetWidth(num)
    EndIf
    wid + 4
    Line(px, py, wid, 0)
    DisplayMath(*num, px+(wid-SetWidth(num))/2, py-SetY2(num), font)
    DisplayMath(*den, px+(wid-SetWidth(den))/2, py+SetY1(den), font)
  EndIf
  DrawingFont(FontID(savefont))
EndProcedure


Procedure CreateMathImage()
  If StartDrawing(WindowOutput(0))
    DrawingMode(1)
    imawid = 0
    imahei = 0
    ForEach *maths()
      set.q = MathSettings(*maths(), 1)
      wid = SetWidth(set)+100
      hei = SetY1(set)+SetY2(set)
      If (wid > imawid)
        imawid = wid
      EndIf
      imahei + hei+10
    Next
    imahei - 10
    StopDrawing()
  EndIf
  wid = GetGadgetAttribute(0, #PB_ScrollArea_InnerWidth)
  If (imawid > wid)
    SetGadgetAttribute(0, #PB_ScrollArea_InnerWidth, imawid)
    *save = lines()
    ForEach lines()
      ResizeGadget(lines()\tex, #PB_Ignore, #PB_Ignore, imawid, #PB_Ignore)
      ResizeGadget(lines()\inp, #PB_Ignore, #PB_Ignore, imawid, #PB_Ignore)
      If lines()\ima
        imayy = GadgetHeight(lines()\ima)
        If imayy
          ima = CreateImage(#PB_Any, imawid, imayy)
          If StartDrawing(ImageOutput(ima))
            xxx = GadgetWidth(lines()\ima)
            DrawImage(GetGadgetState(lines()\ima), 0, 0)
            Box(xxx, 0, imawid-xxx, imayy, RGB(255,255,255))
            StopDrawing()
          EndIf
          SetGadgetState(lines()\ima, ImageID(ima))
        EndIf
      EndIf
    Next
    ChangeCurrentElement(lines(), *save)
  Else
    imawid = wid
  EndIf
  If (imawid > 0) And (imahei > 0)
    image = CreateImage(#PB_Any, imawid, imahei)
    If StartDrawing(ImageOutput(image))
      DrawingMode(1)
      DrawingFont(FontID(1))
      BackColor(RGB(255,0,0))
      Box(0, 0, imawid, imahei, RGB(255,255,255))
      yy = 0
      ForEach *maths()
        set.q = MathSettings(*maths(), 1)
        py = SetY1(set)
        DisplayMath(*maths(), 100, yy+py, 1)
        yy + SetY1(set)+SetY2(set)+10
      Next
      StopDrawing()
    EndIf
  EndIf
  ProcedureReturn image
EndProcedure


Procedure NewInput()
  AddElement(lines())
  wid = GetGadgetAttribute(0, #PB_ScrollArea_InnerWidth)
  pos = GetGadgetAttribute(0, #PB_ScrollArea_InnerHeight)
  OpenGadgetList(0)
  lines()\tex = TextGadget(#PB_Any, 0, pos, 16, inputhei, ">")
  lines()\inp = StringGadget(#PB_Any, 16, pos, wid-16, inputhei, "", #PB_String_BorderLess)
  CloseGadgetList()
  SetGadgetColor(lines()\tex, #PB_Gadget_BackColor, RGB(255,255,255))
  SetGadgetFont(lines()\tex, FontID(0))
  SetGadgetFont(lines()\inp, FontID(0))
  SetActiveGadget(lines()\inp)
  SetGadgetAttribute(0, #PB_ScrollArea_InnerHeight, pos+inputhei)
  SetGadgetAttribute(0, #PB_ScrollArea_Y, pos+inputhei)
EndProcedure


Procedure NewOutput()
  text.s = GetGadgetText(lines()\inp)
  If (LCase(text) = "end") Or (LCase(text) = "quit")
    quit = 1
  Else
    ClearList(*maths())
    len = Len(text)
    string = 0
    save = 0
    For i = 0 To len
      a = PeekB(@text+i)
      If (a = '"')
        string = 1-string
      EndIf
      If ((a = ';') And (string = 0)) Or (i = len)
        newtext.s = Trim(Mid(text,save+1,i-save))
        save = i+1
        If newtext
          *LastMath = mathEval(LCase(newtext))
          newValueVar("ans", copyMath(*LastMath))
          yy + 1
          AddElement(*maths())
          *maths() = *LastMath
        EndIf
      EndIf
    Next
    image = CreateMathImage()
    wid = GetGadgetAttribute(0, #PB_ScrollArea_InnerWidth)
    pos = GetGadgetAttribute(0, #PB_ScrollArea_InnerHeight)
    If (lines()\ima = 0)
      OpenGadgetList(0)
      If (image > 0)
        lines()\ima = ImageGadget(#PB_Any, 0, pos, 0, 0, ImageID(image))
        SetGadgetAttribute(0, #PB_ScrollArea_InnerHeight, pos+ImageHeight(image))
      Else
        lines()\ima = ImageGadget(#PB_Any, 0, pos, 0, 0, 0)
      EndIf
      CloseGadgetList()
      NewInput()
    Else
      vor = GadgetHeight(lines()\ima)
      If (GetGadgetState(lines()\ima) = 0)
        vor = 0
      EndIf
      If (image > 0)
        SetGadgetState(lines()\ima, ImageID(image))
        hei = GadgetHeight(lines()\ima)
      Else
        SetGadgetState(lines()\ima, 0)
        ResizeGadget(lines()\ima, #PB_Ignore, #PB_Ignore, #PB_Ignore, 0)
        hei = 0
      EndIf
      pl = hei-vor
      *nexl.lines = 0
      While NextElement(lines())
        If (*nexl = 0)
          *nexl = lines()
        EndIf
        ResizeGadget(lines()\tex, #PB_Ignore, GadgetY(lines()\tex)+pl, #PB_Ignore, #PB_Ignore)
        ResizeGadget(lines()\inp, #PB_Ignore, GadgetY(lines()\inp)+pl, #PB_Ignore, #PB_Ignore)
        If lines()\ima
          ResizeGadget(lines()\ima, #PB_Ignore, GadgetY(lines()\ima)+pl, #PB_Ignore, #PB_Ignore)
        EndIf
      Wend
      SetGadgetAttribute(0, #PB_ScrollArea_InnerHeight, pos+pl)
      SetActiveGadget(*nexl\inp)
    EndIf
  EndIf
  ProcedureReturn quit
EndProcedure


Procedure WindowCallback(WindowID, Message, wParam, lParam)
  Result = #PB_ProcessPureBasicEvents
  If (Message = #WM_SIZE)
    winwid = WindowWidth(0)
    winhei = WindowHeight(0)
    ResizeGadget(0, 0, 0, winwid, winhei)
  EndIf
  ProcedureReturn Result
EndProcedure


If OpenWindow(0, 0, 0, winwid, winhei, "InterfaceWindow", #PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_SizeGadget|1)
  InitFont()
  If CreateGadgetList(WindowID(0))
    ScrollAreaGadget(0, 0, 0, winwid, winhei, winwid-21, 0, 25)
    CloseGadgetList()
    NewInput()
    AddKeyboardShortcut(0, #PB_Shortcut_Return, 0)
    AddKeyboardShortcut(0, #PB_Shortcut_Up, 1)
    AddKeyboardShortcut(0, #PB_Shortcut_Down, 2)
    AddKeyboardShortcut(0, #PB_Shortcut_Control|#PB_Shortcut_M, 3)
    SetWindowCallback(@WindowCallback(), 0)
  EndIf
  
  
  Repeat
    Event = WaitWindowEvent()
    
    If (Event = #PB_Event_Menu)
      EMID = EventMenu()
      If (EMID = 0)
        ForEach lines()
          If (GetActiveGadget() = lines()\inp)
            Quit = NewOutput()
          EndIf
        Next
      ElseIf (EMID = 1)
        ForEach lines()
          If (GetActiveGadget() = lines()\inp)
            If PreviousElement(lines())
              SetActiveGadget(lines()\inp)
            EndIf
            Break
          EndIf
        Next
      ElseIf (EMID = 2)
        ForEach lines()
          If (GetActiveGadget() = lines()\inp)
            If NextElement(lines())
              SetActiveGadget(lines()\inp)
            EndIf
            Break
          EndIf
        Next
      ElseIf (EMID = 3)
        gad = GetActiveGadget()
        If IsGadget(gad) And *LastMath
          SetGadgetText(gad, strMath(*LastMath))
        EndIf
      EndIf
    EndIf
    
    If (Event = #PB_Event_CloseWindow)
      Quit = 1
    EndIf
    
  Until Quit
EndIf
End


; IDE Options = PureBasic v4.00 (Windows - x86)
; Executable = InterfaceWindow.exe